#!/usr/bin/env python

import time
import sys
import subprocess
import os

# Run the actual command
command = "srun -p haswell10c -n 20 -c 2 --cpu_bin=verbose,core".split()
command.extend(sys.argv[1:])
ret = subprocess.call(command)

# If that failed - fail!
if ret != 0:
    sys.exit(ret)

# If that was succesful, wait for the output file to be available on the filesystem
# This step is necessary because the NFS synchronization is too slow for our workflow.
while not os.path.isfile(sys.argv[2]):
    time.sleep(0.1)
