# Return the list of generated files for a given ini file 
# This is used by the build system, do not use this yourself!

from dune.testtools.parser import parse_ini_file
from dune.testtools.cmakeoutput import printForCMake

import sys

ini = parse_ini_file(sys.argv[1])
section = ini["formcompiler"]
operators = section.get("operators", "r")
operators = [i.strip() for i in operators.split(",")]

def get_filename(operator):
    ssection = ini.get("formcompiler.{}".format(operator), {})
    if ssection.get("filename", None):
        return ssection["filename"]
    else:
        classname = ssection.get("classname", "{}Operator".format(ssection.get("form", operator)))
        return "{}_{}_file.hh".format(sys.argv[2], classname)

result = {"__{}".format(o): get_filename(o) for o in operators}
result["__operators"] = ";".join(operators)

printForCMake(result)
sys.exit(0)
